searchData={"items":[{"type":"module","title":"AshFeistelCipher","doc":"","ref":"AshFeistelCipher.html"},{"type":"macro","title":"AshFeistelCipher.feistel_cipher/1","doc":"","ref":"AshFeistelCipher.html#feistel_cipher/1"},{"type":"module","title":"AshFeistelCipher.Encrypt","doc":"","ref":"AshFeistelCipher.Encrypt.html"},{"type":"module","title":"AshFeistelCipher.Info","doc":"","ref":"AshFeistelCipher.Info.html"},{"type":"function","title":"AshFeistelCipher.Info.feistel_cipher/1","doc":"feistel_cipher DSL entities","ref":"AshFeistelCipher.Info.html#feistel_cipher/1"},{"type":"module","title":"AshFeistelCipher.Transformer","doc":"","ref":"AshFeistelCipher.Transformer.html"},{"type":"function","title":"AshFeistelCipher.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshFeistelCipher.Transformer.html#after?/1"},{"type":"function","title":"AshFeistelCipher.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshFeistelCipher.Transformer.html#after_compile?/0"},{"type":"task","title":"mix ash_feistel_cipher.install","doc":"Installs AshFeistelCipher and FeistelCipher","ref":"Mix.Tasks.AshFeistelCipher.Install.html"},{"type":"task","title":"Example - mix ash_feistel_cipher.install","doc":"```bash\nmix igniter.install ash_feistel_cipher\n```","ref":"Mix.Tasks.AshFeistelCipher.Install.html#module-example"},{"type":"extras","title":"AshFeistelCipher","doc":"# AshFeistelCipher\n\nAshFeistelCipher is an `Ash.Resource` extension for transforming integer attribute values using a Feistel cipher. This enables the generation of non-sequential, unpredictable values from sequential or otherwise predictable integer inputs.","ref":"readme.html"},{"type":"extras","title":"Installation - AshFeistelCipher","doc":"```\nmix igniter.install ash_feistel_cipher\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshFeistelCipher","doc":"Use `AshFeistelCipher` in your `Ash.Resource` and configure the `feistel_cipher` block as follows:\n\n```elixir\ndefmodule MyApp.Post do\n  use Ash.Resource,\n    data_layer: Ash.DataLayer.Postgres,\n    extensions: [AshFeistelCipher]\n\n  attributes do\n    integer_primary_key :id\n\n    # 'seq' is only a source for generating serial integers, so override with primary_key?: false.\n    integer_primary_key :seq, primary_key?: false\n  end\n\n  feistel_cipher do\n    encrypt do\n      source :seq # Source attribute for the Feistel cipher.\n      target :id # Target attribute for the Feistel cipher.\n      bits 40 # Specifies the maximum number of bits for both the source and target integers.\n      bits_confirm \"0x28\" # A confirmation value to prevent unintentional changes to the 'bits' setting.\n    end\n\n    encrypt do\n      # You can define multiple 'encrypt' blocks if you need to configure\n    end\n  end\nend\n```\n\nThen,\n\n```\nmix ash.codegen create_post\n```\n\nwill generate a migration that sets up a database trigger to encrypt the `seq` attribute into the `id` attribute using a Feistel cipher.","ref":"readme.html#usage"},{"type":"extras","title":"See Also - AshFeistelCipher","doc":"* [feistel_cipher](https://github.com/devall-org/feistel_cipher): Provides Ecto migrations for Feistel cipher. `ash_feistel_cipher` integrates this capability into the Ash framework for easy use with Ash resources.","ref":"readme.html#see-also"},{"type":"extras","title":"License - AshFeistelCipher","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}